/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <QtGui>
#include "PrimeNumberTest.h"
#include "mainWindow.h"
#include "./libNumberTheory/libNumberTheory.h"

PrimeNumberTest::PrimeNumberTest(const mainWindow *main)
{
	this->theNumber = new mpz_class(0);
	setupUi(this);
	createConnections();
	initializeDialog();
}

PrimeNumberTest::~PrimeNumberTest()
{
	delete this->theNumber;
}

void PrimeNumberTest::initializeDialog()
{
	QRegExp re("[0-9]*");
	QRegExpValidator *v = new QRegExpValidator(re, this);
	number->setValidator(v);
	number->setText("");
	number->setEnabled(true);
	runButton->setEnabled(false);	
}

void PrimeNumberTest::createConnections()
{

	connect(runButton, SIGNAL(clicked()), this, SLOT(primalityTest()));
	connect(number, SIGNAL(textEdited(const QString &)), this, SLOT(defineNumber()));
	
}

void PrimeNumberTest::defineNumber()
{
	if (number->text().length() != 0) {
		QByteArray nbr = number->text().toAscii();
		*(this->theNumber) = mpz_class(nbr.constData(), 10);
	}
	if (*(this->theNumber) != 0) {
		runButton->setEnabled(true);
	}	
}

void PrimeNumberTest::primalityTest()
{
	
	
	
}

void PrimeNumberTest::updateAlgorithm()
{
	
	
	
}

#include "PrimeNumberTest.moc"
