/*************************************************************************** 
 *   Copyright (C) 2007 by apterium   *                                      
 *   apterium@gmail.com   *                                                  
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  * 
 *   it under the terms of the GNU General Public License as published by  * 
 *   the Free Software Foundation; either version 3 of the License, or     * 
 *   (at your option) any later version.                                   * 
 *                                                                         * 
 *   This program is distributed in the hope that it will be useful,       * 
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 *   GNU General Public License for more details.                          * 
 *                                                                         * 
 *   You should have received a copy of the GNU General Public License     * 
 *   along with this program; if not, write to the                         * 
 *   Free Software Foundation, Inc.,                                       * 
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 ***************************************************************************/

#include "CipherEngine.h"

namespace LibClassicalCrypto
{
	CipherEngine::~CipherEngine()
	{
		
	}
	
	std::vector<libalgebra::RingZnElement> CipherEngine::toRingZnElement(const std::vector<mpz_class>& text,
									     const libalgebra::RingZn* ring) const
	{
		std::vector<libalgebra::RingZnElement> ret;
		for (std::vector<mpz_class>::size_type i = 0 ; i < text.size() ; i++) {
			ret.push_back(libalgebra::RingZnElement(text.at(i), ring) );
		}
		return ret;
	}

	std::vector<mpz_class> CipherEngine::toMpz_class(const std::vector<libalgebra::RingZnElement>& text) const
	{
		std::vector<mpz_class> ret;
		for (std::vector<libalgebra::RingZnElement>::size_type i = 0 ; i < text.size() ; i++) {
			ret.push_back(text.at(i).getPositiveValue() );
		}	
		return ret;
	}



} //namespace LibClassicalCrypto

