/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __LIB_ALGEBRA_DIMENSION_MISMATCH_EXCEPTION_H
#define __LIB_ALGEBRA_DIMENSION_MISMATCH_EXCEPTION_H

#include <exception>

namespace libalgebra
{
	/**
	 * @short Exception thrown when operations on matrices fail due to
	 * dimension constraint.
	 * This class provides a generic exception for matrices operations
	 * failures, for example when multiplying two matrices which do not have
	 * the same dimensions.
	 *
	 * @author apterium
	 */
	class DimensionMismatchException : public std::exception
	{
	public:
		/**
		 * Constructs a new NonInvertibleElementException instance.
		 * 
		 */
		DimensionMismatchException();

		/**
		 * Destructor.
		 *
		 */
		~DimensionMismatchException() throw();
	};
	
	
} //namespace libalgebra

#endif //__LIB_ALGEBRA_DIMENSION_MISMATCH_EXCEPTION_H
