/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

namespace libalgebra
{
	template<class T, class R>
	ExtensionField<T, R>::ExtensionField(const DensePolynomial<T, R>& polynom)
		: Ring()
	{
		this->polynomial = new DensePolynomial<T, R>(polynom);
	}
	
	template<class T, class R>
	ExtensionField<T, R>::~ExtensionField()
	{
		delete this->polynomial;
	}
	
	template<class T, class R>
	mpz_class ExtensionField<T, R>::characteristic() const
	{
		return this->polynomial->getUnderlyingRing()->characteristic();
	}
	
	template<class T, class R>
	mpz_class ExtensionField<T, R>::cardinality() const
	{
		return (this->characteristic()) * (this->polynomial->degree());
	}
	
	
	
	
} //namespace libalgebra
