/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "RingZElement.h"

namespace libalgebra{
	
	RingZElement::RingZElement(const mpz_class& k, RingZ& r)
	{
		this->value = new mpz_class(k);
		this->ring = &r;
	}
	
	RingZElement::RingZElement(const RingZElement& copy) 
		: RingElement(copy)
	{
		this->value = new mpz_class(*(copy.value));
		this->ring = copy.ring;
	}
	
	RingZElement::~RingZElement()
	{
		delete this->value;
	}

	
	

} //namespace libalgebra
