/***************************************************************************
 *   Copyright (C) 2007 by Andrea Moro   *
 *   andrea_moro@email.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include <QApplication>
#include <QLocale>
#include <QTranslator>
#include <QFile>
#include "mainWindow.h"

/**
 * Main entry to the program. Currently, there is no utilization of any
 * given parameters.
 *
 */
int main(int argc, char *argv[])
{
	Q_INIT_RESOURCE(application);

/* BEGIN translation section */
	QTranslator translator;
	QString locale = QLocale::system().name().left(2);
/* searching in a predefinite path the translation to
   localize tha application according to the system */
	if (QFile::exists(QString("/usr/share/cryptoolinux/translation/translation_")+locale+".qm")) {
		translator.load(QString("/usr/share/cryptoolinux/translation/translation_")+locale+".qm");
	}
	else {
		if (QFile::exists(QString("../doc/translation/translation_")+locale+".qm")) {
			translator.load(QString("../doc/translation/translation_")+locale+".qm");
		}
	}
/* END translation section*/

	QApplication *app = new QApplication(argc, argv);
	mainWindow *newWin = new mainWindow(qobject_cast<QWidget*>(app));
	newWin->showMaximized();
	app->installTranslator(&translator);
	app->setActiveWindow(newWin);
	int ret = app->exec();
	delete newWin;
	delete app;
	return ret;
}
